* QUICKFIND, component of ST Digger 3.1
* Copyright (C) 1990-2002  Han Driesen
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
* 
* <han.driesen@hccnet.nl> 

*	I	d0		lengte van patroon
*	I	a0		begin van tekst c.q. tekst-pointer
*	I	a1		bovengrens van tekst
*	I	a2		begin van patroon
*	I	a3		tabel met pos van tekens t.o.v. eind patroon
*	I	a4		tabel met verschuivingen in patroon
*		a5,d1,d2,d3	hulpvariabelen

qfind:	movem.l $0004(sp),d0/a0-a4	; parameters naar registers
	suba.w	d0,a1			; corrigeer voor lengte van patroon
	moveq	#0,d1			; NB: hogere bytes blijven steeds 0
	move.b	(a2),d2 		; 1e teken van patroon
*
*  Hier begint de snelzoeklus
*
loop1:	adda.w	d1,a0			; schuif tekst-pointer
loop2:	cmpa.l	a1,a0			; nog voldoende tekst over ?
	bhi.s	exit2			; nee
	move.b	-$01(a0,d0.w),d1	; ja, haal teken uit tekst
	move.b	$00(a3,d1.w),d1 	; pos van teken t.o.v. eind patroon
	bne.s	loop1			; teken niet aan eind van patroon
*
*  Laatste teken uit patroon is nu gelokaliseerd in de tekst
*
	cmp.b	(a0)+,d2		; test eerste teken van patroon
	bne.s	loop2			; mis, ga naar snelzoeklus
loop3:	addq.b	#1,d1			; telling voor passende tekens
	cmp.b	d0,d1			; patroon afgewerkt ?
	bcc.s	exit1			; ja, patroon gevonden
	move.b	(a0)+,d3		; nee, haal volgend teken uit tekst
loop4:	cmp.b	$00(a2,d1.w),d3 	; past het patroon tot zover?
	beq.s	loop3			; ja, ga door
	move.b	$00(a4,d1.w),d1 	; nee, raadpleeg schuiftabel
	bmi.s	loop2			; geen shift: ga naar snelzoeklus
	cmpa.l	a1,a0			; voorlopige check op einde tekst
	bls.s	loop4			; nauwkeuriger kijken onnodig
	lea	$00(a1,d1.w),a5 	; pas bovengrens tijdelijk aan
	cmpa.l	a5,a0			; toch nog voldoende tekst over?
	bls.s	loop4			; ja, probeer nieuwe positie in patroon
*
*  Het zoekproces is nu -al of niet succesvol- afgelopen
*
exit1:	suba.w	d1,a0			; correctie voor start van patroon
exit2:	move.l	a0,d0
	rts

	END
